  (defun c:PipeBlkIn_FROMBLOCK_TITLE_LAYER( / ht post bname obj obj1 base1 p1 p2 di ang atang X Y pAtt ang2  ang3 att tx)
  (vl-load-com)
  (setq temperr *error*) ;store *error*
  (setq *error* trap1) ;re-assign *error*
  (setvar "cmdecho" 0)
  (setvar "OSMODE" 0)

  (setq temperr *error*) ;store *error*
  (setq *error* trap1) ;re-assign *error*
  (setvar "cmdecho" 0)

  (setq ht (getreal "\nSet Length factor (If Drawing Units mm-Set 1000, If Drawig Units m-Set 1)<1000>: "))
    (if (= ht nil)
      (setq ht (atof "1000"))
  )

   (initget "P&Id Or Regular")
   (if (null (setq post (getkword "\nChoose [P&Id/Regular] <Regular>: ")))
      (setq post "Regular")
   )

   (if (= post "Regular") (setvar "OSMODE" 1))

  (setq ht (/ 1 ht))

     (if (setq ensel (entsel "\nSelect Block: ")) ;select the block object to copy
       (setq bname (cdr (assoc 2 (entget (car ensel)))))
     )

   (setq obj (car ensel)) ;set the block object to varaible

   (setq base1 (getpropertyvalue (car ensel) "Position" 1 "X")) ;get the source block base point 
   (setq p1 (getpoint "\nDestination Point: "))

 (while 1
   (command "COPY" obj "" base1 p1 ) ;;Insert the pipe block
   ;;(command "COPY" ensel "" x1 p1 ) ;;Insert the pipe block
   (setq obj1 (entlast))

   (command "line" p1 (setq b (getpoint p1 "\nDistance")) "")
   (command "Erase" (entlast) "")

   (setq obj2 (vlax-ename->vla-object obj1)) ;; set the pipe object to a VLAX object for the attribute rotation function

   ;;(setq p2 (getpoint "\nDistance: "))            ;; select the end point coordinates of the pipe to set the pipe length and for the Distance calculation
   (setq p2 b) ;; select the end point coordinates of the pipe to set the pipe length and for the Distance calculation
   (setq di (distance p1 p2))                         ;; calculate the pipe length
   (setpropertyvalue obj1 "d1" (rtos di 2 10))  ;; set the pipe length to the pipe block length parameter
   (setpropertyvalue obj1 "QUANTITY" (rtos (* di ht) 2 3))

   (setq ang (angle p1 p2)) ;; Calculate the pipe rotation angle
   (setq attdist (/ di 2)) ;; dist to move  TITLE attribute
   (setq pAtt (polar p1 ang attdist)) ;;set the middle point of the pipe

   (setq X (getpropertyvalue obj1 "ScaleX")) ;; get the Block ScaleX value to check if the object is mirrored 
   (setq Y (getpropertyvalue obj1 "ScaleY"))  ;; get the Block ScaleY value to check if the object is mirrored 



   ( ;; check if the object is mirrored
     if (< (+ X Y) 1) 
       (setq ang (angle p2 p1)) ;;if the object is mirrored rotate the object rotation angle in 180 Degrees
    )

   (setpropertyvalue obj1 "Rotation" ang) ;; set the object rotation


   (
     if (<= (* 0.5 pi) ang (* 1.5 pi))
         (setq atang (+ ang  pi))
         (setq atang ang)
   )

   (setq ang2 (- atang (/ pi 2)))
   (setq ang3 (+ atang (/ pi 2)))
   (if (= post "Regular")
     (progn
        (setq pAtt1 (polar pAtt ang2 42)) ;;set the attribute point of the  a regular pipe
        (setq pAtt2 (polar pAtt ang3 42)) ;;set the middle point of the a P&Id pipe order
     )
     (progn
        (setq pAtt1 (polar pAtt ang2 110)) ;;set the middle point of the a P&Id pipe title 
        (setq pAtt2 (polar pAtt ang3 110)) ;;set the middle point of the a P&Id pipe order
     )
   )

   (setq LA (vla-get-layer obj2)) ;; Get The Block Layer
   (setq tx (strcat "PIPE " LA)) ;; set the Title Text

           ( ;; rotate the object attributes to the object rotation

              foreach att (vlax-invoke Obj2 'GetAttributes)
              (vla-put-Rotation att atang) ;;Rotate Attributes
                     ( ;; Open If
                       if (= "TITLE" (strcase (vla-get-tagstring att))) ;; Check if TITLE Attribute Exist
                            (progn
                               (setpropertyvalue obj1 "TITLE" tx)
                               (vlax-put att 'insertionpoint pAtt1)
                            ) ;; Close progn
                     ) ;; Close If

                     ( ;; Open If
                       if (= "ORDER" (strcase (vla-get-tagstring att))) ;; Check if TITLE Attribute Exist
                            (progn
                               (vlax-put att 'insertionpoint pAtt2)
                            ) ;; Close progn
                     ) ;; Close If


           ) ;; Close rotate the object attributes to the object rotation and Add Text To Title Attribute

  (command "._REDRAWALL") ;;redraw the object

   (if (= post "Regular")
      (setq p1 (getpoint "\nNew Base Point: "))  
      (setq p1 p2) 
   )

 );end while

 (setvar "OSMODE" 1)
(princ)
)

  (defun trap1 (errmsg) ;define function   ;;when ESC is entered
     (setq *error* temperr) ;restore *error*
     (prompt "\nResetting System Variables ") ;inform user 
        (if (= post "P&Id") (command "_erase" obj1 ""))
        (if (= post "P&Id") (command "_erase" obj ""))
        (if (= post "P&Id") (command "_erase" (entlast) "")) 
        (setvar "cmdecho" 1)
        (setvar "OSMODE" 1)
        (setvar "ATTREQ" 1) ;;enable the attributes window popup before exiting the lisp	
     (princ)
  )